{ 27.      .    
   .   ,     
}
unit str25n27;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ULoad, UCommon, ExtCtrls, Grids, UDraw;

type
  TFormMain = class(TForm)
    ButtonOpen: TButton;
    OD: TOpenDialog;
    ButtonSolve: TButton;
    SGMain: TStringGrid;
    LabelTypes: TLabel;
    LabelV: TLabel;
    LabelArr: TLabel;
    MemoMain: TMemo;
    procedure ButtonOpenClick(Sender: TObject);
    procedure ButtonSolveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;
  Times:TTimes;
  MinPer,perestanovka:TArray;
  MinTime:integer;
implementation

{$R *.dfm}

function MasToString(aMas:TArray;n:integer):string;
var k:integer;
begin
  result:=IntToStr(aMas[1]);
   for k:=2 to n do
    result:=result+' '+IntToStr(aMas[k]);
end;

procedure TFormMain.ButtonOpenClick(Sender: TObject);
begin
 if OD.Execute and LoadFile(OD.FileName,Times,perestanovka) then
   Begin
    Draw(SGMain,Times);
    ButtonSolve.Enabled:=true;
    LabelArr.Caption:=MasToString(perestanovka,n);
   end;
end;

procedure swap(var x1,x2:integer);
var t:integer;
begin
 t:=x1;
 x1:=x2;
 x2:=t;
end;

function max(x1,x2:integer):integer;
begin
 if x2 > x1 then
  result:=x2
 else
  result:=x1;
end;

procedure CopyArr(var source,dest:TArray);
var i:integer;
begin
 for i:=1 to maxN do
  dest[i]:=source[i];
end;

function FillMatr(ap:TArray):integer;
var a:array[1..MaxN,1..m] of integer;
    i,j:integer;
begin
 a[1,1]:=Times[1,ap[1]];
 for j:=2 to m do
  a[1,j]:=a[1,j-1]+Times[j,ap[1]];
 for i:=2 to n do
  a[i,1]:=a[i-1,1]+Times[1,ap[i]];
 for j:=2 to m do
  for i:=2 to n do
   a[i,j]:=max(a[i-1,j],a[i,j-1])+Times[j,i];
 result:=a[n,m];
end;

procedure solve(ap:TArray;i:integer);
var j,mt:integer;
begin
 if i=n then
  begin
   mt:=FillMatr(ap);
   FormMain.MemoMain.Lines.Add('  '+MasTostring(ap,n)+'  = '+IntToStr(mt));
   if minTime > mt then
    begin
     minTime:=mt;
     CopyArr(ap,minPer);
    end;
  end
 else
 begin
  solve(ap,i+1);
  for j:=i+1 to n do
   if ap[i]<>ap[j] then
    begin
     swap(ap[i],ap[j]);
     solve(ap,i+1);
     swap(ap[i],ap[j]);
    end;
 end;
end;

procedure TFormMain.ButtonSolveClick(Sender: TObject);
begin
MemoMain.Clear;
 solve(perestanovka,1);
 ShowMessage(' : '+
              IntToStr(mintime)+
            '   '+
              MasToString(minPer,n));
end;

initialization
minTime:=High(integer);
end.
